#include <jni.h>
#include <stdlib.h>
#include <android/bitmap.h>

extern "C" JNIEXPORT jobject JNICALL Java_jp_espresso3389_pdf_1render_ByteBufferHelper_newDirectBuffer(JNIEnv *env, jclass cls, jlong ptr, jlong size)
{
    return env->NewDirectByteBuffer(reinterpret_cast<void *>(static_cast<size_t>(ptr)), size);
}

extern "C" JNIEXPORT jlong JNICALL Java_jp_espresso3389_pdf_1render_ByteBufferHelper_malloc(JNIEnv *env, jclass cls, jlong size)
{
    return static_cast<jlong>(reinterpret_cast<size_t>(malloc(size)));
}

extern "C" JNIEXPORT void JNICALL Java_jp_espresso3389_pdf_1render_ByteBufferHelper_free(JNIEnv *env, jclass cls, jlong ptr)
{
    free(reinterpret_cast<void *>(static_cast<size_t>(ptr)));
}

extern "C" JNIEXPORT jlong JNICALL Java_jp_espresso3389_pdf_1render_ByteBufferHelper_objectToGlobalRef(JNIEnv *env, jclass cls, jobject jobject)
{
    return static_cast<jlong>(reinterpret_cast<intptr_t>(env->NewGlobalRef(jobject)));
}

extern "C" JNIEXPORT void JNICALL Java_jp_espresso3389_pdf_1render_ByteBufferHelper_deleteGlobalRef(JNIEnv *env, jclass cls, jlong ptr)
{
    env->DeleteGlobalRef(reinterpret_cast<jobject>(static_cast<intptr_t>(ptr)));
}

extern "C" JNIEXPORT jlong JNICALL Java_jp_espresso3389_pdf_1render_ByteBufferHelper_objectToJObject(JNIEnv *env, jclass cls, jobject jobject)
{
    return static_cast<jlong>(reinterpret_cast<intptr_t>(jobject));
}

extern "C" JNIEXPORT jobject JNICALL Java_jp_espresso3389_pdf_1render_ByteBufferHelper_jObjectToObject(JNIEnv *env, jclass cls, jlong ptr)
{
    return reinterpret_cast<jobject>(static_cast<intptr_t>(ptr));
}

extern "C" JNIEXPORT jlong JNICALL Java_jp_espresso3389_pdf_1render_ByteBufferHelper_lockBitmapPixels(JNIEnv *env, jclass cls, jobject bitmap)
{
    void *pixels = nullptr;
    AndroidBitmap_lockPixels(env, bitmap, &pixels);
    return static_cast<jlong>(reinterpret_cast<intptr_t>(pixels));
}

extern "C" JNIEXPORT void JNICALL Java_jp_espresso3389_pdf_1render_ByteBufferHelper_unlockBitmapPixels(JNIEnv *env, jclass cls, jobject bitmap)
{
    AndroidBitmap_unlockPixels(env, bitmap);
}
